zoukankan      html  css  js  c++  java
  • hdu 5045 Contest

                                                                           Contest

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
    Total Submission(s): 1777    Accepted Submission(s): 719


    Problem Description
    In the ACM International Collegiate Programming Contest, each team consist of three students. And the teams are given 5 hours to solve between 8 and 12 programming problems.

    On Mars, there is programming contest, too. Each team consist of N students. The teams are given M hours to solve M programming problems. Each team can use only one computer, but they can’t cooperate to solve a problem. At the beginning of the ith hour, they will get the ith programming problem. They must choose a student to solve this problem and others go out to have a rest. The chosen student will spend an hour time to program this problem. At the end of this hour, he must submit his program. This program is then run on test data and can’t modify any more.

    Now, you have to help a team to find a strategy to maximize the expected number of correctly solved problems.

    For each problem, each student has a certain probability that correct solve. If the ith student solve the jth problem, the probability of correct solve is Pij .

    At any time, the different between any two students’ programming time is not more than 1 hour. For example, if there are 3 students and there are 5 problems. The strategy {1,2,3,1,2}, {1,3,2,2,3} or {2,1,3,3,1} are all legal. But {1,1,3,2,3},{3,1,3,1,2} and {1,2,3,1,1} are all illegal.

    You should find a strategy to maximize the expected number of correctly solved problems, if you have know all probability
     
    Input
    The first line of the input is T (1 ≤ T ≤ 20), which stands for the number of test cases you need to solve.

    The first line of each case contains two integers N ,M (1 ≤ N ≤ 10,1 ≤ M ≤ 1000),denoting the number of students and programming problem, respectively.

    The next N lines, each lines contains M real numbers between 0 and 1 , the jth number in the ith line is Pij .
     
    Output
    For each test case, print a line “Case #t: ”(without quotes, t means the index of the test case) at the beginning. Then a single real number means the maximal expected number of correctly solved problems if this team follow the best strategy, to five digits after the decimal point. Look at the output for sample input for details.
     
    Sample Input
    1 2 3 0.6 0.3 0.4 0.3 0.7 0.9
     
    Sample Output
    Case #1: 2.20000
     
    题意:有N个学生刷M道程序题,规定程序题从第一题开始一题一题往后做,不得跳题,并且给定第i个学生做第j题的概率为pij,要求做对所有这M道题的最大期望。
    思路:学生数N比较小,所以可以用状态压缩dp,设定一个集合S:包含当前所有已经做题的人,dp[v][S]:做到第v题为止,集合S代表当前做过题的人,dp记录此时做对前v道题的最大期望
    动态转移方程为:dp[i][x] = max(dp[i][x], dp[i - 1][S] + p[v][i]);其中x=S|1<<v;
    AC代码:
    #define _CRT_SECURE_NO_DEPRECATE
    #include<iostream>
    #include<algorithm>
    #include<string>
    #include<set>
    #include<map>
    #include<vector>
    #include<queue>
    #include<functional>
    using namespace std;
    const int N_MAX= 10+1,M_MAX=1000+2;
    double p[N_MAX][M_MAX];
    int N, M;
    double dp[M_MAX][1<<N_MAX];//集合S:到v题为止,已经答题的队员的组合,dp[v][S]:正在做第v题,到第v题为止的解题情况组成S,的期望值
    int main() {
        int T,t=0;
        scanf("%d",&T);
        while (T--) {
            t++;
            scanf("%d%d", &N, &M);
            for (int i = 0; i < N; i++) {
                for (int j = 0; j < M; j++) {
                    scanf("%lf", &p[i][j]);
                }
            }
            memset(dp, 0, sizeof(dp));//没有记录的那些情况用0记录,表示不存在,譬如dp[0][1<<j|1<<i],明显只做了一道题,集合S中却显示有两个人做过题
            for (int i = 0; i < N; i++) {                                                             //显然这种情况是不存在的
                dp[0][1 << i] = p[i][0];//分别记录第i个人做了第一题的情况
            }
    
            for (int i = 1; i < M; i++) {
                for (int S = 0; S <= (1 << N) - 1; S++) {
                    if (dp[i- 1][S]<1e-6)  continue;//前面的情况如果不存在,就不能往下推,故跳过
                    for (int v = 0; v < N; v++) {
                        if (!(S >> v & 1)) {//如果学生v还没有参加过
                            int x = S | (1 << v);
                            if (x == (1 << N) - 1)x = 0;//加上这个同学之后集合里所有的人都做过题,那么新的一轮开始,并且所有同学做过题的记录清0
                            dp[i][x] = max(dp[i][x], dp[i - 1][S] + p[v][i]);
                        }
                    }
                }
            }
            double sum = 0;
            for (int i = 0; i <= (1 << N) - 1; i++) {
                sum = max(sum, dp[M - 1][i]);
            }
            printf("Case #%d: %.5f
    ", t, sum);
        }
    return 0;
    }
        
     
     
  • 相关阅读:
    数据库面试题
    MySQL表的导入
    MySQL表的导出
    MySQL安装mydumper
    MySQL中的日志
    动态数组实现下压栈
    动态数组
    设计模式之迭代器
    设计模式之组合模式
    设计模式之状态模式
  • 原文地址:https://www.cnblogs.com/ZefengYao/p/6686865.html
Copyright © 2011-2022 走看看